/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narDebug.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/**
 *  @file
 *  @author Satoru Osako
 */

#ifndef NAR_DEBUG_H__
#define NAR_DEBUG_H__

#include "narPort.h"
#include "narFlags.h"

namespace mw { namespace nar
{
    /** fobO̕`ǗNXłB
     */
    class Debug_cl
    {
    public:
        /** fobO`ǗtO
         */
        enum Switch_e
        {
            me_ViewNone,
            /// NA邽߂ɕKvȃtO
            NAR_EFLAG( me_ViewClear ),
            /// ֊s`
            NAR_EFLAG( me_ViewLineCandidates ),
            /// }[J[pbV`
            NAR_EFLAG( me_ViewCheckMesh ),
            /// ̌X`
            NAR_EFLAG( me_ViewEdgeSlope ),
            /// ŏ@Tv`
            NAR_EFLAG( me_ViewSample ),
            me_ViewLastFlag,
            me_ViewInfo = static_cast< s32 >( me_ViewLastFlag ) - 1,
            me_SwitchEnd
        };

        /** fobOXCb`擾
         */
        static Flags_tc< u8, Switch_e > & GetrSwitch() { return instance().m_Flags; }
    private:
        Flags_tc< u8, Switch_e >    m_Flags;

        static Debug_cl & instance()
        {
            static Debug_cl debug;
            return debug;
        }
    };
}
}


#endif
