/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narFlags.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/**
 *  @file
 *  @author Satoru Osako
 */

#ifndef NAR_FLAGS_H__
#define NAR_FLAGS_H__

namespace mw { namespace nar
{
    /** tOǗp̃[eBeBNXłB
     *  @tparam T ϐ̑傫^
     *  @tparam F tǑ^(enum)
     */
    template < typename T, typename F >
    class Flags_tc
    {
    public:
        Flags_tc()
             : m_Flags( static_cast< T >( 0 ) )
        {}

        /** Flag̃NA
         */
        void Clear()
        {
            m_Flags = static_cast< T >( 0 );
        }

        /** w肳ꂽtO𗧂Ă
         */
        void TurnOn( F flags )
        {
            m_Flags = static_cast< T >( static_cast< int >( m_Flags ) | static_cast< int >( flags ) );
        }

        /** w肳ꂽtO~낷
         */
        void TurnOff( F flags )
        {
            m_Flags = static_cast< T >( static_cast< int >( m_Flags ) & ~static_cast< int >( flags ) );
        }

        /** w肳ꂽtOgO
         */
        void Toggle( F flags )
        {
            m_Flags = static_cast< T >( static_cast< int >( m_Flags ) ^ static_cast< int >( flags ) );
        }

        /** w肳ꂽtOZbg
         */
        void Set( bool b, F flags )
        {
            if ( b )    TurnOn( flags );
            else        TurnOff( flags );
        }

        /** w肳ꂽtÔAǂꂩĂΐ^
         */
        bool IsAnyOn( F flags ) const
        {
            return ( m_Flags & flags ) != 0;
        }

        /** w肳ꂽtOSėĂΐ^
         */
        bool IsAllOn( F flags ) const
        {
            return ( m_Flags & flags ) == flags;
        }
    private:
        T   m_Flags;
    };
}
}

/**
 *  enumgbitflaggpۂ֗̕}NB
 *  enumbitɂȂB
 */
#define NAR_EFLAG( x )  x, x##_false_bottom_ = ( (int)x << 1 ) -1

#endif
