/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narMarkerDatabase.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/**
 *  @file
 *  @author Satoru Osako
 */
#ifndef NAR_MARKER_DATABASE_H__
#define NAR_MARKER_DATABASE_H__

#include "narConfig.h"
#include "narMarkerTemplate.h"

namespace mw { namespace nar
{
    class MarkerPattern_st;

    /** o}[J[ev[go^f[^x[XNXłB
     *
     */
    class MarkerDatabase_cl
    {
    public:
        /** @param  th  }[J[ǂf邽߂̔肵lB(-1.0 - 1.0)
         *
         *	}[J[ƎĂ摜̏ꍇA1.0ɋ߂֘ÂŁA臒l1.0ɋ߂ÂƁA
         *	֘A`FbNł܂B
         */
        MarkerDatabase_cl( f32 th = 0.5f )
             : m_TemplateNum( 0 ), m_Threshold( th ), mp_Template( 0 )
        {
        }

        /** }[J[ev[go^܂B
         *	@retval true  o^ł܂B
         *	@retval false o^ł܂łBo^unsigned long̍őlɒBĂēo^ł܂B
         */
        bool Register( MarkerTemplate_st & r_Template );

        /**
         *  }[J[ev[go^܂B
         *	@retval true  o^܂B
         *	@retval false w肳ꂽev[ǵAf[^x[XɌ܂łB
         */
        bool Unregister( MarkerTemplate_st & r_Template );

        /**
         *  }[J[ev[gSēo^܂B
         */
        void UnregisterAll()
        {
            m_TemplateNum 	= 0;
            mp_Template		= 0;
        }

        /**
         *  }[J[ev[go^Ă邩ǂ𒲂ׂ܂B
         */
        bool IsRegistered( const MarkerTemplate_st & cr_Template );

        /**
         * @param  th  }[J[ǂf邽߂̔肵lB(-1.0 - 1.0) 傫ƁAȂ܂B0.0͊֘AȂ-1.0͔]\܂B
         */
        void SetThreshold( f32 th ){ m_Threshold = th; }

        /**
         * ݂̃}[J[ǂf邽߂̂̔肵l擾܂B
         */
        f32 GetThreshold() const { return m_Threshold; }

        /// @cond DEV
        /** }[J[T
         */
        const MarkerTemplate_st * Find( s32 * p_Dir, f32 * p_Score, const MarkerPattern_st & cr_Pattern );
        /// @endcond
    private:
        u32                     m_TemplateNum;
        /// }[J[ǂ肷邵l
        f32                     m_Threshold;
        MarkerTemplate_st *     mp_Template;
    };
}
}

#endif
