/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narMarkerTemplate.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/**
 *  @file
 *  @author Satoru Osako
 */
#ifndef NAR_MARKER_TEMPLATE_H__
#define NAR_MARKER_TEMPLATE_H__

#include "narVec2.h"
#include "narMarkerPattern.h"

namespace mw { namespace nar
{
    enum
    {
        e_MarkerDir_Top = 0,
        e_MarkerDir_Left,
        e_MarkerDir_Bottom,
        e_MarkerDir_Right,
        e_MarkerDirNum
    };

    /** }[J[̏ێ\̂łB
     */
    struct MarkerTemplate_st
    {
        /// oꂽۂɕԂ}[J[ID(̒l͎wł܂)
        s32                     id;
        /// }[J[̘g̃AXyNg(W/H)
        f32                     aspectRatio;
        /// [hWnł̃}[J[̍
        f32                     sideLength;
        /// }[J[̉摜p^[f[^
        MarkerPattern_st        pattern;
        /// ̃ev[gւ̃|C^B
        MarkerTemplate_st *     p_Next;
    };
}
}

#endif
