/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     sampledemos\common\narDemoPhoto.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/**
 *  @file
 *  @author Satoru Osako
 */
#ifndef NAR_DEMO_PHOTO_H__
#define NAR_DEMO_PHOTO_H__

#include <nn.h>

namespace demo
{
    class RenderSystemDrawing;
}
namespace mw { namespace nar
{
    struct Vec2F_st;
}
}
//=====================================================================
/**
 *  Photo
 */
class Photo_cl
{
public:
    Photo_cl()
         : map_Image( 0 ), m_TextureId( 0 )
    {}

    /** 
     */
    void    Initialize( demo::RenderSystemDrawing * p_RenderSystem, nn::fnd::ExpHeap * p_Heap );
    void    Draw();
    void    Draw( const f32 left, const f32 top, const f32 scale );
    void    DrawPattern( const mw::nar::Vec2F_st & r_p0, f32 size, const mw::nar::Vec2F_st * cap_Points );
    /** I
     */
    void    Finalize();

    u16 *   GetpImage() { return map_Image; }
private:
    u16 *                       map_Image;
    GLuint                      m_TextureId;
    demo::RenderSystemDrawing * mp_RenderSsytem;
    nn::fnd::ExpHeap *          mp_Heap;
};

#endif
