﻿/*---------------------------------------------------------------------------*
  Project:  Horizon

  Copyright (C)Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 58466 $
 *---------------------------------------------------------------------------*/

#include "GuiUtil.h"

namespace
{
    // レンダラ
    demo::RenderSystemDrawing* s_pRenderSystem = NULL;
    // テキストライター
    scene::TextWriter* s_pTextWriter = NULL;
}

namespace scene
{

// 描画オブジェクトを登録します。
void RegisterDrawers(demo::RenderSystemDrawing* pRenderSystem, TextWriter* pTextWriter)
{
    s_pRenderSystem = pRenderSystem;
    s_pTextWriter   = pTextWriter;
}

// GUIライブラリが使用するレンダラを取得します。
demo::RenderSystemDrawing* GetRenderSystem()
{
    return s_pRenderSystem;
}

// GUIライブラリが使用するテキストライターを取得します。
TextWriter* GetTextWriter()
{
    return s_pTextWriter;
}

// 線分で箱を描画します。
void util::DrawBox(f32 x, f32 y, f32 width, f32 height, f32 lineWidth)
{
    // ライン幅を設定する
    s_pRenderSystem->SetLineWidth(lineWidth);
    // 左上→右上
    s_pRenderSystem->DrawLine(x, y, x + width, y);
    // 右上→右下
    s_pRenderSystem->DrawLine(x + width, y, x + width, y + height);
    // 右下→左下
    s_pRenderSystem->DrawLine(x + width, y + height, x, y + height);
    // 左下→左上
    s_pRenderSystem->DrawLine(x, y + height, x, y);
}

} // namespace scene
