# -*- coding: sjis -*-
require "optparse"
require "fileutils"
#===============================================================================
module NAR
#-------------------------------------------------------------------------------
# }[J[rbg}bvNX Ƃ肠24bit/rgb̂
class MarkerBmp
  attr_reader :file_name, :buf, :height, :width

  # RXgN^łB
  # file_name :: Ǎރt@C𖼂w肵܂
  def initialize( file_name )
    @file_name = file_name
    load_image( file_name )
  end

  # rbg}bvt@CǍ݂܂B
  # file_name :: bmpt@C
  def load_image( file_name )
    # e|̃obt@
    tmp_buf = nil

    # t@Cf[^Ǎ
    File.open( file_name, "rb") do |bmp|
      tmp_buf = bmp.read
    end

    # obt@̃TCY
    buf_size = tmp_buf[2, 4].unpack("l*").first

    # ƍ̎擾
    @width  = tmp_buf[18, 4].unpack("l*").first
    @height = tmp_buf[22, 4].unpack("l*").first

    # C[W̃obt@擾܂B
    @buf = tmp_buf[54, buf_size]
  end

  # w肵_rgbl擾
  # x :: sNZ
  # y :: sNZc
  def get_color( x, y )
    # TODO: x, y͈̔̓`FbN
    line_size = @width * 3 + (4 - (@width * 3) % 4) % 4
    p = (@height - 1 - y) * line_size + x * 3

    # ruby1.9ȏ̏ꍇAruby1.8.7ꂽordĂԕKv
    # ordȂꍇruby1.8.6Ƃ݂ȂĂ̂܂ܓǍ
    if( @buf[p].respond_to? :ord )
      b = @buf[p].ord
      g = @buf[p+1].ord
      r = @buf[p+2].ord
    else
      b = @buf[p]
      g = @buf[p+1]
      r = @buf[p+2]
    end

    return [r, g, b]
  end
  
  # 摜̎wʒuƂ̎ӂ̃sNZŕωF擾܂B
  # x :: ̈ʒuisNZwj
  # y :: c̈ʒuisNZwj
  def get_average_color( x, y )
    arr_dx = [0,0,-1,0,1]
    arr_dy = [0,-1,0,1,0]

    cnt = arr_dx.size

    r = g = b = 0
    0.upto(cnt-1) do |point|

      cx = x + arr_dx[point]
      next if ( cx >= @width )

      cy = y + arr_dy[point]
      next if ( cy >= @height ) 
      
      c = get_color(cx,cy)
      r += c[0]
      g += c[1]
      b += c[2]
    end

    # ς̐FzŕԂ܂
    [r,g,b].map{|v| MarkerUtil.to_rgb5(v)/cnt}
    
  end
  
  # RgXgp̃e[u쐬܂B
  # v :: -127127܂ł̃RgXgl
  def contrast_table(v)
    cont_tbl = []
    
    k = 1.0
    if v>0
      k=255.0/(255.0-2.0*v.to_f)
    else
      k=(255.0+2.0*v.to_f)/255.0
    end
    
    # 0-255̃e[u
    0.upto(255) do |i|
      v = k * (i.to_f-127.5) + 127.5
      cont_tbl << [0,[255, v].min].max.to_i
    end
    
    cont_tbl
  end

  # RgXg𒲐܂
  # image :: BMP摜
  # v :: -127127܂ł̃RgXgl
  def contrast!(v)
    ctbl = contrast_table(v)

    0.upto(@buf.size-1) do |i|
      @buf[i] = ctbl[@buf[i]]
    end

    self
  end

end

#-------------------------------------------------------------------------------
# }[J[ev[gNX
class MarkerTemplate
  attr_reader :id
  attr_reader :aspect
  attr_reader :side_length
  attr_reader :pattern
  attr_reader :offset
  attr_reader :weight
  attr_reader :divide
  attr_reader :average
  attr_reader :stdevp
  attr_reader :bmp_file

  # id :: }[J[id
  # image :: }[J[̉摜
  # side_length :: side length
  # corp :: w肵}[J[Ƃ݂Ȃꍇ̈ʒȕ
  #         :left, :top, :width, :heightL[ƂnbVŎw肷
  # disable_offset :: ItZbg𗘗p邩ǂ
  # divide :: TvOiq̕
  def initialize( id, image, side_lenght=4.0, crop={}, disable_offset=false, divide=15 )

    # t@C
    @bmp_file = image.file_name

    # IDZbg
    @id = id

    # Zbg
    @divide = divide

    # cropnil̏ꍇ͏
    crop = {:left=>0, :top=>0, :width=>image.width, :height=>image.height} if !crop

    # A̎w肪Ȃ΃rbg}bv̕ƍ̂܂܎g
    l = crop.has_key?(:left)   ? crop[:left]   : 0
    t = crop.has_key?(:top)    ? crop[:top]    : 0
    w = crop.has_key?(:width)  ? crop[:width]  : image.width
    h = crop.has_key?(:height) ? crop[:height] : image.height

    # AXyNg̎Zo
    @aspect = w*1.0/h

    # side length 
    @side_length = side_lenght

    # TvÕp^[擾
    raw_pattern = get_raw_pattern(image, l, t, w, h )

    # ItZbgl擾
    if !disable_offset
      offset = raw_pattern.inject(0){|t,v| t + v} / raw_pattern.size
    else
      offset = 0
    end

    # p^[畽ς
    @pattern = raw_pattern.map{|v| v-offset}

    # p^[l̍v
    sum_val  = @pattern.inject(0){|t,v| t + v}

    # p^[l̂Q̍v
    sum_pow2 = @pattern.inject(0){|t,v| t + (v*v) }

    # p^[l̕
    @average = sum_val*1.0 / @pattern.size

    # W΍
    @stdevp  = Math.sqrt(sum_pow2 / @pattern.size - @average ** 2)

    # ϒl̓ItZbgƂăZbg
    @offset = offset

    # dݕt̏ l16
    @weight = []
    (@pattern.size/3).times{ @weight << 16 }
  end

  # 摜p^[擾܂B
  # w肳ꂽiq̓_Ƃ̎ӂS_̕ϒlzɂĕԂ܂B
  # image  :: ΏۂƂȂ摜
  # left   :: }[J[̍ʒu
  # top    :: }[J[̏ʒu
  # width  :: }[J[̕
  # height :: }[J[̍
  def get_raw_pattern(image, left, top, width, height)
    raw_pattern = []

    # bmp͕ʂ̉摜OƂȂ邽߁A
    # PɕŊiq_쐬F擾
    h_pitch = width  * 1.0 /(@divide + 1)
    v_pitch = height * 1.0 /(@divide + 1)

    1.upto(@divide) do |v|
      1.upto(@divide) do |h|
        # ς̐F擾ăp^[Ƃ
        raw_pattern << image.get_average_color(left+(h*h_pitch).round, top+(v*v_pitch).round)
      end
    end
    # p^[Ԃ܂B
    raw_pattern.flatten
  end

  def get_divide_code(arr, tab_cnt)
    pattern_text = []
    1.upto(@divide) do |v|
      line = []
      1.upto(@divide) do |h|
        0.upto(2) do |i|
          line << arr[v*@divide+h+i]
        end
      end
      pattern_text << line.join(",")
    end

   tab = ""
   1.upto(tab_cnt){tab += "\t"}
    pattern_text.join("\n#{tab}")
  end
end

#-------------------------------------------------------------------------------
# }[J[o̓[eBeB
module MarkerUtil
  class << self
  private
    # p^[̃R[h擾܂B
    # template :: ev[g
    # tabs :: Cfg^u
    def get_pattern_code( template, tabs = "" )
      code = ""
      template.pattern.each_with_index do |v,i|
        if i%(template.divide*3) == 0
          code << "\n#{tabs}"
        end
        code << sprintf("%#2d,", v)
      end
      code
    end
    
    
    # dݕt̃R[h擾܂B
    # template :: ev[g
    # tabs :: Cfg^u
    def get_weight_code( template, tabs = "" )
      code = ""
      template.weight.each_with_index do |v,i|
        if i%(template.divide) == 0
          code << "\n#{tabs}"
        end
        code << sprintf("%#2d,", v)
      end
      code
    end
    
    # ̃ev[gzɂR[hƂĎ擾܂B
    # templates :: ev[g̔z
    def get_templates_code( templates )
code=<<-_CODE_
/**
 * [Caution]
 * This code is a sample easily-generated template. (not for the product)
 * Use marker_maker demo and replace this template code.
 */
mw::nar::MarkerTemplate_st ga_Markers[#{templates.size}] ={
#{
templates.inject("") do |r,t|
  "#{r}#{get_template_code_part(t).chomp},\n"
end
}
_CODE_
code + "}; // ga_Markers[#{templates.size}]"
    end
    
    # P̃ev[gR[hƂĎ擾܂B
    # template :: ev[g
    def get_single_template_code( template )
code=<<-_CODE_
/**
 * [Caution]
 * This code is a sample easily-generated template. (not for the product)
 * Use marker_maker demo and replace this template code.
 */
mw::nar::MarkerTemplate_st g_Marker =
#{get_template_code_part(template)}
_CODE_
code.strip + ";"
    end
    
    # ev[g̈ꕔR[hƂĎ擾܂B
    # template :: ev[g
    def get_template_code_part( template )
code=<<-_CODE_
{ // #{File.basename(template.bmp_file.gsub(/\.tmp/,""))}
#{template.id}, 		// id
#{template.aspect}, // aspect
#{template.side_length},	// side length
{
#{get_pattern_code(template, "\t")}
	#{template.offset},
	#{template.average},
	#{template.stdevp},
},
}
_CODE_
    end

  public
    # p̕\`o
    # template :: ev[g
    def get_pattern_table( template )
      code = ""
      vals = []
      template.pattern.each_with_index do |v,i|
        vals << v
        if vals.size == 3
          puts vals.join("\t")
          vals.clear
        end
      end
      code
    end

    # p̕\`o͂ŏo͂܂B
    # template :: ev[g
    # ofile :: o͐t@C
    def print_pattern_table( template, ofile=nil )
      o = ofile || $stdout
      o.puts File.basename(template.bmp_file)
      o.puts get_pattern_table(template)
      o.puts ""
    end

    # ЂƂ̃ev[gɂăR[ho͂܂B
    # template :: ev[g
    # ofile :: o͐t@C
    def print_single_template_code( template, ofile=nil)
      o = ofile || $stdout
      o.puts get_single_template_code(template)
    end

    # ̃ev[gR[hƂďo͂܂BB
    # templates :: ev[g̔z
    # ofile :: o͐t@C
    def print_templates_code(templates, ofile=nil)
      o = ofile || $stdout
      o.puts get_templates_code(templates)
    end
    

    # ev[gbmp`̃t@Cɂĕۑ܂B
    # template :: ev[g
    # out_dir :: o͐̃tH_
    def save_template_as_bmp(template, out_dir=nil)
      
      fname = File.join(File.dirname(template.bmp_file), "__#{File.basename(template.bmp_file)}")
      fname = File.join(out_dir,fname) if out_dir
 
      # ƍ
      width = height = template.divide
      
      # ς𑫂Ė߂
      field = []
      col = []
      template.pattern.each_with_index do |c,cnt|
        c+=template.offset
        idx = ( cnt / 3 ) % width
        if cnt % 3 == 0
          col<<0
          col[ idx ] |= c << 10
        elsif cnt % 3 == 1
          col[ idx ] |= c << 5
        elsif cnt % 3 == 2
          col[ idx ] |= c
          if idx == width - 1
            rest = 4 - col.size % 4
            rest.times do
              col.push(0)
            end
            field = col + field
            col = []
          end
        end
      end

      File.open(fname, "wb") do |file|
        file.write(["BM", 54 + width * height * 2, 54].pack("a2Vx4V"))
        file.write([40, width, height, 1, 16].pack("VVVvvx24"))
        file.write(field.pack("v*"))
      end
      
    end
    
    # J[l8bit5bitɂ
    # val :: ϊΏۂ̒l
    def to_rgb5( val )
      val >> 3
    end
    
    # J[l5bit8bitɖ߂
    # val :: ϊΏۂ̒l
    def to_rgb8( val )
      val << 3
    end
    
  end # class<self
  
end
end # NAR

#===============================================================================
# bmpev[g쐬܂B
# id :: }[J[ID
# bmp :: rbg}bv
# side_length :: side length
# crop :: ؂ʒuwsNZŎw
#         {:left=>ʒu, :top=>ʒu, :width=>, :height=>}
# contrast_value :: RgXg
# disable_offset :: ItZbg̗L
def create_template(id, bmp, side_lenght, crop, contrast_value, disable_offset)
  # bmp[h
  marker_bmp = NAR::MarkerBmp.new(bmp)

  # RgXg
  if contrast_value != 0
    marker_bmp.contrast!(contrast_value)
  end

  # bmpev[g쐬
  template = NAR::MarkerTemplate.new( id, marker_bmp, side_lenght, crop, disable_offset )
end

# ̃ev[go͂܂B
# templates :: ev[g̔z
# ofile :: o͐t@C
def print_templates( templates, ofile )
  NAR::MarkerUtil.print_templates_code( templates, ofile )
end

# ev[go͂܂B
# template :: ev[g
# ofile :: o͐t@C
def print_single_template( template, ofile, is_save_bmp = false )
  NAR::MarkerUtil.print_single_template_code( template, ofile )
end

# ev[g̑
# img_file :: ̓C[Wւ̃pX
def proc_template_img( img_file )
    # .png̏ꍇ
    if /\.png$/ =~ img_file
      # .png̏ꍇ̓Ro[găe|.bmp쐬
      tmp_file = img_file + ".tmp"
      system( "png2bmp.exe #{img_file} #{tmp_file}" )
      # ϊbmpt@CubNɓn
     yield tmp_file

      # e|bmp폜
      FileUtils.rm_rf( tmp_file )

    # .bmp̏ꍇ
    else
      
      # ϊbmpt@CubNɓn
      yield img_file
    end

end

#==============================================================================
# main
# gF
# ruby ar_marker_maker.rb -i path/to/template.bmp
# 
# ]ꍇ
# ruby ar_marker_maker.rb "%f" -i sample_marker/hatena.png  --output=hatena.txt --crop=47,71,543,869
# IvV̏ڍׂ
# ruby ar_marker_maker.rb --help ŕ\
#==============================================================================
params = {:id=>0, :side_length=>4.0, :contrast=>0, :save_bmp=>false, :disable_offset=>false}

# ̃p[X
ARGV.options do |opt|
  opt.on('-v','--version','Show the version number and quit') do |val|
    puts("NARMarkerTemplateMaker 1.1.0")
  end
  
  opt.on('-i','--input=path/to/imgfile or imgdir', 'Template image file or directory.') do |val|
    params.merge!({:input => val})
  end

  opt.on('-o','--output=path/to/outputfile', 'Output template code file.') do |val|
    params.merge!({:output => val})
  end

  opt.on('--id=id','Template id.') do |val|
    params.merge!({:id => val})
  end

  opt.on('--side_length=val','Side length value.') do |val|
    params.merge!({:side_length => val})
  end

  opt.on('--crop=l,t,w,h', 'Crop image option. l:left t:top w:width h:height') do |val|
    c = val.scan(/\d+/)
    raise "Invalid crop argument." if( c.size != 4 )
    c.map!{|v| v.to_i}
    params.merge!({:crop=> {:left=>c[0], :top=>c[1], :width=>c[2], :height=>c[3]}})
  end

  opt.on('--contrast=value', 'Adjust contrast value 0:normal(default) -100:minimum 100:maxmum') do |val|
    params.merge!({:contrast => val.to_i})
  end

  opt.on('--save_bmp', 'Save created pattern as bmp file') do |val|
    params.merge!({:save_bmp => val})
  end

  opt.on('--disable_offset', 'Disable offset of pattern') do |val|
    params.merge!({:disable_offset => val})
  end

  opt.parse!
end

if !params[:input]
  puts "HELP: ruby ar_marker_maker.rb --help"
end


# o͐̎w肪ΊJ
ofile = nil
if params[:output]
  ofile = File.open(params[:output],"w")
end

begin
  # w肳ꂽt@C܂̓tH_.bmpt@Cev[g쐬
  templates = []

  if params[:input] && File.file?(params[:input]) # t@C̏ꍇ

    img_file = params[:input]
    template = nil

    # 摜t@Cev[g쐬
    proc_template_img( img_file ) do |bmp_file|
      template = create_template(params[:id], bmp_file, params[:side_length], params[:crop], params[:contrast], params[:disable_offset])
    end

    print_single_template( template, ofile )
    if( params[:save_bmp] )
      NAR::MarkerUtil.save_template_as_bmp( template )
    end

  elsif params[:input] && File.directory?(params[:input]) # tH_̏ꍇ
    id = params[:id].to_i
    # fBNg.bmp^.pngt@CT
    Dir.glob(File.join(params[:input], "*.{bmp,png}")) do |img_file|
      next if /^__/ =~ File.basename(img_file)

      # 摜t@Cev[g쐬
      proc_template_img( img_file ) do |bmp_file|
        templates << create_template(id, bmp_file, params[:side_length], params[:crop], params[:contrast], params[:disable_offset])
      end

      id+=1
    end
    # ev[go
    print_templates( templates, ofile )
    if( params[:save_bmp] )
      templates.each do |t|
        NAR::MarkerUtil.save_template_as_bmp( t )
      end
    end
  end
#rescue => e
#  puts "Create Template Failed!"
#  puts e
#ensure
  ofile.close if ofile && !ofile.closed?
end

